diff --git a/Documentation/conf.py b/Documentation/conf.py
index d4fdf6a3875a83..51f48a57eb706c 100644
--- a/Documentation/conf.py
+++ b/Documentation/conf.py
@@ -337,6 +337,10 @@ if  html_theme == 'alabaster':
         'font_family': 'serif',
     }
 
+    html_css_files = [
+            'fonts.css',
+    ]
+
 sys.stderr.write("Using %s theme\n" % html_theme)
 
 # Add any paths that contain custom static files (such as style sheets) here,
diff --git a/Documentation/sphinx-static/IBMPlexSans-Bold.woff2 b/Documentation/sphinx-static/IBMPlexSans-Bold.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..aee2f963e123b76ef8fda0f8b71f7f8e73b296be
GIT binary patch
diff --git a/Documentation/sphinx-static/IBMPlexSans-BoldItalic.woff2 b/Documentation/sphinx-static/IBMPlexSans-BoldItalic.woff2
diff --git a/Documentation/sphinx-static/IBMPlexSans-Italic.woff2 b/Documentation/sphinx-static/IBMPlexSans-Italic.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..57523c9d34353ceaa6cd4cb7820f83ac570d836c
GIT binary patch
diff --git a/Documentation/sphinx-static/IBMPlexSans-Regular.woff2 b/Documentation/sphinx-static/IBMPlexSans-Regular.woff2
diff --git a/Documentation/sphinx-static/fonts.css b/Documentation/sphinx-static/fonts.css
new file mode 100644
index 00000000000000..6a8378d9e312a7
--- /dev/null
+++ b/Documentation/sphinx-static/fonts.css
@@ -0,0 +1,68 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+
+/* @font-face definitions */
+/* IBM Plex Sans, regular */
+@font-face {
+	font-display: swap;
+	font-family: "IBM Plex Sans";
+	font-style: normal;
+	font-weight: 400;
+	src: local("IBM Plex Sans"),
+	     url("IBMPlexSans-Regular.woff2") format("woff2");
+}
+
+/* IBM Plex Sans, italic */
+@font-face {
+	font-display: swap;
+	font-family: "IBM Plex Sans";
+	font-style: italic;
+	font-weight: 400;
+	src: local("IBM Plex Sans"),
+	     url("IBMPlexSans-Italic.woff2") format("woff2");
+}
+
+/* IBM Plex Sans, bold */
+@font-face {
+	font-display: swap;
+	font-family: "IBM Plex Sans";
+	font-style: normal;
+	font-weight: 700;
+	src: local("IBM Plex Sans"),
+	     url("IBMPlexSans-Bold.woff2") format("woff2");
+}
+
+/* IBM Plex Sans, bold italic */
+@font-face {
+	font-display: swap;
+	font-family: "IBM Plex Sans";
+	font-style: italic;
+	font-weight: 700;
+	src: local("IBM Plex Sans"),
+	     url("IBMPlexSans-BoldItalic.woff2") format("woff2");
+}
+/* End @font-face definitions */
+
+/* Fallback fonts */
+:root {
+	--fallback-family-sans: ui-sans-serif, system-ui, -apple-system, "Helvetica Neue", "Segoe UI", Roboto, Ubuntu, Cantarell, "Noto Sans", sans-serif;
+}
+
+body {
+	font-family: "IBM Plex Sans", var(--fallback-family-sans);
+}
+
+div.sphinxsidebar h3, div.sphinxsidebar h4, div.sphinxsidebar input {
+	font-family: "IBM Plex Sans", var(--fallback-family-sans);
+}
+
+div.admonition p.admonition-title {
+	font-family: "IBM Plex Sans", var(--fallback-family-sans);
+}
+
+span.menuselection {	
+	font-family: "IBM Plex Sans", var(--fallback-family-sans);
+	/* Distinguish menu text from regular prose by giving it
+	 * the same background color as inline pre-formatted text. */
+	background-color: #ecf0f3;
+	color: #222;	
+}