diff --git a/Documentation/sphinx-static/Newsreader_14pt-Bold.woff2 b/Documentation/sphinx-static/Newsreader_14pt-Bold.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..bbe393623c78a19ec7586f72136762fc76cab741
GIT binary patch
diff --git a/Documentation/sphinx-static/Newsreader_14pt-BoldItalic.woff2 b/Documentation/sphinx-static/Newsreader_14pt-BoldItalic.woff2
diff --git a/Documentation/sphinx-static/Newsreader_14pt-Italic.woff2 b/Documentation/sphinx-static/Newsreader_14pt-Italic.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..70fcb0b416881ec723db43c29e16d498873a46df
GIT binary patch
diff --git a/Documentation/sphinx-static/Newsreader_14pt-Regular.woff2 b/Documentation/sphinx-static/Newsreader_14pt-Regular.woff2
diff --git a/Documentation/sphinx-static/fonts.css b/Documentation/sphinx-static/fonts.css
index 6a8378d9e312a7..3424002e18eeb8 100644
--- a/Documentation/sphinx-static/fonts.css
+++ b/Documentation/sphinx-static/fonts.css
@@ -1,6 +1,45 @@
 /* SPDX-License-Identifier: GPL-2.0 */
 
 /* @font-face definitions */
+/* Newsreader, regular */
+@font-face {
+	font-display: swap;
+	font-family: "Newsreader";
+	font-style: normal;
+	font-weight: 400;
+	src: local("Newsreader"),
+	     url("Newsreader_14pt-Regular.woff2") format("woff2");
+}
+
+/* Newsreader, italic */
+@font-face {
+	font-display: swap;
+	font-family: "Newsreader";
+	font-style: italic;
+	font-weight: 400;
+	src: local("Newsreader"),
+	     url("Newsreader_14pt-Italic.woff2") format("woff2");
+}
+
+/* Newsreader, bold */
+@font-face {
+	font-display: swap;
+	font-family: "Newsreader";
+	font-style: normal;
+	font-weight: 700;
+	src: local("Newsreader"),
+	     url("Newsreader_14pt-Bold.woff2") format("woff2");
+}
+
+/* Newsreader, bold italic */
+@font-face {
+	font-display: swap;
+	font-family: "Newsreader";
+	font-style: italic;
+	font-weight: 700;
+	src: local("Newsreader"),
+	     url("Newsreader_14pt-BoldItalic.woff2") format("woff2");
+}
 /* IBM Plex Sans, regular */
 @font-face {
 	font-display: swap;
@@ -45,6 +84,7 @@
 /* Fallback fonts */
 :root {
 	--fallback-family-sans: ui-sans-serif, system-ui, -apple-system, "Helvetica Neue", "Segoe UI", Roboto, Ubuntu, Cantarell, "Noto Sans", sans-serif;
+	--fallback-family-serif: ui-serif, system-ui, -apple-system, "Times New Roman", "Roboto Serif", serif;
 }
 
 body {
@@ -66,3 +106,7 @@ span.menuselection {
 	background-color: #ecf0f3;
 	color: #222;	
 }
+
+div.body h1, div.body h2, div.body h3, div.body h4, div.body h5, div.body h6 {
+	font-family: "Newsreader", var(--fallback-family-serif);
+}